from collections import defaultdict

NAME_MAP = {
    "Pandemic_1": "Cases1",
    "Pandemic_2": "Cases2",
    "Pandemic_3": "Cases3",
    "Pandemic_4": "Cases4",
    "Pandemic_5": "Cases5",
    "Pandemic_6": "Hosp1",
    "Pandemic_7": "Hosp2",
    "Pandemic_8": "Deaths1",
    "Pandemic_9": "Deaths2",
    "Pandemic_10": "Deaths3",
    "Pandemic_11": "Deaths4",
    "Pandemic_12": "Deaths5",
    "proportion_vax": "Vax1",
    "Pandemic_Response_2": "Vax2",
    "Administered": "Vax3",
    "Pandemic_Response_4": "Gather1",
    "Pandemic_Response_5": "Gather2",
    "Pandemic_Response_6": "Gather3",
    "Pandemic_Response_7": "Gather4",
    "Pandemic_Response_8": "SaH",
    "Pandemic_Response_9": "Curfew",
    "Pandemic_Response_10": "Mask1",
    "Pandemic_Response_11": "Mask2",
    "Pandemic_Response_12": "School",
    "Pandemic_Response_13": "ARP",
    "Pandemic_Response_14": "PPP",
    "Pandemic_Response_15": "CARES",
    "Consumption": "Cons1",
    "TG_Consumption": "Cons2",
    "DG_Consumption": "Cons3",
    "NDG_Consumption": "Cons4",
    "S_Consumption": "Cons5",
    "Demand_6": "Employment1",
    "Demand_7": "Employment2",
    "GDP": "GDP",
    "Supply_2": "UI",
    "Supply_3": "PartR",
    "Supply_4": "UR",
    "Supply_5": "RPFI",
    "Supply_6": "FixAss",
    "Supply_7": "Prod",
    "Monetary_1": "CPI",
    "Monetary_2": "CPIU",
    "Monetary_3": "PCE",
    "Monetary_4": "PCEC",
    "Monetary_5": "TBill1mo",
    "Monetary_6": "TBill6mo",
    "Monetary_7": "TBill1yr",
    "Monetary_8": "TBill5yr",
    "Monetary_9": "TBill10yr",
    "Monetary_10": "TBill30yr",
    "Monetary_11": "FFR",
}

FACTORS = {
    "Cases1": ("Global", "Pandemic"),
    "Cases2": ("Global", "Pandemic"),
    "Cases3": ("Global", "Pandemic"),
    "Cases4": ("Global", "Pandemic"),
    "Cases5": ("Global", "Pandemic"),
    "Hosp1": ("Global", "Pandemic"),
    "Hosp2": ("Global", "Pandemic"),
    "Deaths1": ("Global", "Pandemic"),
    "Deaths2": ("Global", "Pandemic"),
    "Deaths3": ("Global", "Pandemic"),
    "Deaths4": ("Global", "Pandemic"),
    "Deaths5": ("Global", "Pandemic"),
    "Vax1": ("Global", "Response"),
    # "Vax2": ("Global", "Response"),
    "Vax3": ("Global", "Response"),
    "Gather1": ("Global", "Response"),
    "Gather2": ("Global", "Response"),
    "Gather3": ("Global", "Response"),
    "Gather4": ("Global", "Response"),
    # "SaH": ("Global", "Response"),
    "Curfew": ("Global", "Response"),
    "Mask1": ("Global", "Response"),
    "Mask2": ("Global", "Response"),
    "School": ("Global", "Response"),
    "ARP": ("Global", "Response"),
    "PPP": ("Global", "Response"),
    "CARES": ("Global", "Response"),
    "School": ("Global", "Response"),
    "Cons1": ("Global", "Consumption"),
    "Cons2": ("Global", "Consumption"),
    "Cons3": ("Global", "Consumption"),
    "Cons4": ("Global", "Consumption"),
    "Cons5": ("Global", "Consumption"),
    "Employment1": ("Global", "Employment"),
    "Employment2": ("Global", "Employment"),
    "UI": ("Global", "Employment"),
    "PartR": ("Global", "Employment"),
    "UR": ("Global", "Employment"),
    "CPI": ("Global", "Inflation"),
    "CPIU": ("Global", "Inflation"),
    "PCE": ("Global", "Inflation"),
    "PCEC": ("Global", "Inflation"),
    "RPFI": ("Global", "Uncat"),
    "FixAss": ("Global", "Uncat"),
    "Prod": ("Global", "Uncat"),
    "GDP": ("Global", "Uncat"),
    "TBill1mo": ("Global", "Uncat"),
    "TBill6mo": ("Global", "Uncat"),
    "TBill1yr": ("Global", "Uncat"),
    "TBill5yr": ("Global", "Uncat"),
    "TBill10yr": ("Global", "Uncat"),
    "TBill30yr": ("Global", "Uncat"),
    "FFR": ("Global", "Uncat"),
}

FACTORS_GROUPED = defaultdict(list)
for key, (_, second) in FACTORS.items():
    FACTORS_GROUPED[second].append(key)
FACTORS_GROUPED = dict(FACTORS_GROUPED)

GROUPED_FACTORS = {}
for key, values in FACTORS_GROUPED.items():
    for value in values:
        GROUPED_FACTORS[value] = key

DIFF_COLS = [
    "Cases1",
    "Cases2",
    "Cases3",
    "Cases4",
    "Cases5",
    "Hosp1",
    "Hosp2",
    "Deaths1",
    "Deaths2",
    "Deaths3",
    "Deaths4",
    "Deaths5",
]

LOG_DIFF_COLS = [
    "Cons1",
    "Cons2",
    "Cons3",
    "Cons4",
    "Cons5",
    "Employment1",
    "Employment2",
    "CPI",
    "CPIU",
    "PCE",
    "PCEC",
    "RPFI",
    "FixAss",
    "Prod",
    "GDP",
    "UI",
]

UNMODIFIED_COLS = set(FACTORS).difference(DIFF_COLS).difference(LOG_DIFF_COLS)
